#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "callbacks.h"
#include "support.h"

//helper for knowing which proplist we're adding to

void on_psk_activated (GtkButton *button, gpointer user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	gtk_widget_set_sensitive (GTK_WIDGET(impl->w_PSK), TRUE);
	return;
}


void on_cert_activated (GtkButton *button, gpointer user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	gtk_widget_set_sensitive (GTK_WIDGET(impl->w_PSK), FALSE);
	//insert code to activate import CERT button once we have coded support for Certificates
	return;
}



void
on_configInterface_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	impl->interface_widget = glade_xml_get_widget (impl->xml, "nm-openswan-conf-interface");
	
	gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_IP), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_SnM), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_DNS), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_WINS), FALSE );

	//set the callbacks, then show
	g_signal_connect ((gpointer) impl->w_vip_dhcp, "toggled",
                  G_CALLBACK (on_vip_DHCP_toggled),
                  impl);
	g_signal_connect ((gpointer) impl->w_vip_manual, "toggled",
					  G_CALLBACK (on_vip_Manual_toggled),
					  impl);
	g_signal_connect_swapped ((gpointer) impl->w_confIntOK, "clicked",
							  G_CALLBACK (on_conf_int_OK_clicked),
							  impl);
	g_signal_connect ((gpointer) impl->w_confIntCANCEL, "clicked",
					  G_CALLBACK (on_conf_int_Cancel_clicked),
					  impl);
					  
	/* make the widget reusable */
	g_signal_connect (GTK_OBJECT (impl->widget), "delete-event", 
			    G_CALLBACK (gtk_widget_hide_on_delete), NULL);

	gtk_widget_show_all (impl->interface_widget);	
	return;
}


void
on_configXauth_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	impl->interface_widget = glade_xml_get_widget (impl->xml, "nm-openswan-conf-xauth");
	
	//set the callbacks, then show
	g_signal_connect (impl->w_promptXauth, "toggled",
					  G_CALLBACK (on_promptXauth_toggled),
					  impl);
	g_signal_connect_swapped (impl->w_confXauthOK, "clicked",
							  G_CALLBACK (on_confXauthOK_clicked),
					          impl);
	g_signal_connect (impl->w_confXauthCancel, "clicked",
					  G_CALLBACK (on_confXauthCancel_clicked),
					  impl);

	/* make the widget reusable */
	g_signal_connect (GTK_OBJECT (impl->widget), "delete-event", 
			    G_CALLBACK (gtk_widget_hide_on_delete), NULL);
	
	gtk_widget_show_all (impl->interface_widget);
	return;
}


void
on_P1_Add_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	impl->proposal_widget = glade_xml_get_widget (impl->xml, "nm-openswan-conf-newproposal");
	newProp_source = 1;
	//set the callbacks, then show
	g_signal_connect_swapped ((gpointer) impl->w_newProp_OK, "clicked",
							  G_CALLBACK (on_newProp_OK_clicked),
							  impl);
	g_signal_connect ((gpointer) impl->w_newProp_Reset, "clicked",
					  G_CALLBACK (on_newProp_Reset_clicked),
					  impl);
	g_signal_connect ((gpointer) impl->w_newProp_Cancel, "clicked",
					  G_CALLBACK (on_newProp_Cancel_clicked),
					  NULL);

	/* make the widget reusable */
	g_signal_connect (GTK_OBJECT (impl->widget), "delete-event", 
			    G_CALLBACK (gtk_widget_hide_on_delete), NULL);	

	gtk_widget_show_all (impl->proposal_widget);
	
	return;
}


void
on_P1_Delete_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_P1_DeleteAll_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_P2_Add_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	impl->proposal_widget = glade_xml_get_widget (impl->xml, "nm-openswan-conf-newproposal");
	newProp_source = 2;
	//set the callbacks, then show
	g_signal_connect_swapped ((gpointer) impl->w_newProp_OK, "clicked",
							  G_CALLBACK (on_newProp_OK_clicked),
							  GTK_OBJECT (impl));
	g_signal_connect ((gpointer) impl->w_newProp_Reset, "clicked",
					  G_CALLBACK (on_newProp_Reset_clicked),
					  impl);
	g_signal_connect ((gpointer) impl->w_newProp_Cancel, "clicked",
					  G_CALLBACK (on_newProp_Cancel_clicked),
					  NULL);
	
	gtk_widget_show_all (impl->proposal_widget);
	return;
}


void
on_P2_Delete_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_P2_DeleteAll_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_newconn_OK_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_newconn_Cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_main_quit();
	return;
}


void
on_newProp_OK_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
//process data and assign to pointers in the impl stuct
// for P1_ProposalList and P2_ProposalList
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	GtkTreeIter iter;
	
	switch (newProp_source)
	{
		case 1 :
			gtk_list_store_append (impl->params->P1_ProposalList, &iter);
			gtk_list_store_set (impl->params->P1_ProposalList, &iter, 
								0, g_strdup ((gtk_combo_box_get_active_text (impl->w_newprop_enc))), 
								1, g_strdup ((gtk_combo_box_get_active_text (impl->w_newprop_auth))), 
								-1 
								);
		    return;
		
		case 2 :
			gtk_list_store_append (impl->params->P2_ProposalList, &iter);
			gtk_list_store_set (impl->params->P2_ProposalList, &iter, 
								0, g_strdup ((gtk_combo_box_get_active_text(impl->w_newprop_enc))), 
								1, g_strdup ((gtk_combo_box_get_active_text (impl->w_newprop_auth))), 
								-1 
								);
		    return;
		
		default :
			//major error here this helper variable for the switch
			//should always be set before we get here.
			nm_warning("Trying to get Proposals and helper variable isn't set");
		    return;
	}
}


void
on_newProp_Reset_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	gtk_combo_box_set_active (impl->w_newprop_enc, -1);
	gtk_combo_box_set_active (impl->w_newprop_auth, -1);
}


void
on_newProp_Cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	gtk_widget_destroy(impl->proposal_widget);
	return;
}


void
on_vip_DHCP_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	if (gtk_toggle_button_get_active (togglebutton))
	{
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_IP), FALSE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_SnM), FALSE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_DNS), FALSE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_WINS), FALSE );
		gtk_expander_set_expanded(impl->w_confInt_Expander, FALSE);
	}
	return;
}


void
on_vip_Manual_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	if (gtk_toggle_button_get_active (togglebutton))
	{
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_IP), TRUE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_SnM), TRUE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_DNS), TRUE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_vip_WINS), TRUE );
		gtk_expander_set_expanded(impl->w_confInt_Expander, TRUE);
	}
	return;
}


void
on_promptXauth_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	//enable Configure button for this option
	if (gtk_toggle_button_get_active ( togglebutton) )
	{	
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_xauthUsername), TRUE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_xauthPassword), TRUE );
		return;
	}
	else
	{
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_xauthUsername), FALSE );
		gtk_widget_set_sensitive( GTK_WIDGET(impl->w_xauthPassword), FALSE );
		return;
	}	
}


void
on_confXauthOK_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	
	if ((impl->w_promptXauth))
	{
		g_string_assign (impl->params->xauthUsername, NMOS_STRING_VAL_NONE);
		g_string_assign (impl->params->xauthPassword, NMOS_STRING_VAL_NONE);
	}
	else
	{
		g_string_assign (impl->params->xauthUsername, gtk_entry_get_text (impl->w_xauthUsername));
		g_string_assign (impl->params->xauthPassword, gtk_entry_get_text (impl->w_xauthPassword));
	}
	

}


void
on_confXauthCancel_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	gtk_widget_destroy(impl->xauth_widget);
	return;
}


void
on_interfaceMode_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	if (gtk_toggle_button_get_active ( togglebutton ) )
	{	
		gtk_widget_set_sensitive ( GTK_WIDGET (impl->w_configInterface) , TRUE );
		return;
	}
	else
	{
		gtk_widget_set_sensitive ( GTK_WIDGET (impl->w_configInterface) , FALSE );
		return;
	}	
}


void
on_xauth_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	if (gtk_toggle_button_get_active ( togglebutton ) )
	{	
		gtk_widget_set_sensitive ( GTK_WIDGET (impl->w_configXauth) , TRUE );
		return;
	}
	else
	{
		gtk_widget_set_sensitive ( GTK_WIDGET (impl->w_configXauth) , FALSE );
		return;
	}	
}


void
on_conf_int_OK_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	if ( gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON(impl->w_vip_dhcp)) )
	{
		impl->params->vip_dhcp = TRUE;
		return;
	}
	else
	{
		impl->params->vip_dhcp = FALSE;
		return;
	}
}


void
on_conf_int_Cancel_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	//gtk_widget_destroy(gtk_widget_get_toplevel(button));
	return;
}


void
on_Import_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_newconn_Reset_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	libnmos_clear_widget (impl);
	return;
}


void
on_auto_keepalive_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) user_data;
	if ( (gtk_toggle_button_get_active ( togglebutton )) )
	{	
		gtk_widget_set_sensitive ( GTK_WIDGET (impl->w_keepalivefreq) , TRUE );
		return;
	}
	else
	{
		gtk_widget_set_sensitive ( GTK_WIDGET (impl->w_keepalivefreq) , FALSE );
		return;
	}	

}

