/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glib/gi18n-lib.h>
#include <string.h>

#define NM_VPN_API_SUBJECT_TO_CHANGE

#include "libnmos.h"
#include "callbacks.h"
#include "support.h"


static const char *
impl_get_display_name (NetworkManagerVpnUI *self)
{
	return _("IPsec VPN Client (openswan)");
}


static const char *
impl_get_service_name (NetworkManagerVpnUI *self)
{
	return "org.freedesktop.NetworkManager.openswan";
}


static GtkWidget *
impl_get_widget (NetworkManagerVpnUI *self, GSList *properties, GSList *routes, const char *connection_name)
{
	GSList *i;
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;

	//libnmos_clear_widget (impl);

	if (connection_name != NULL)
		gtk_entry_set_text (impl->w_name, connection_name);
	
	/* Process the data stream for key,value pairs and populate data widgets with value
	 * -> TODO - we may want to set the values of struct impl->params 
	 * but we'll wait and see it that's really necessary (why waste memory when we don't need it)
	 */

	//create the first row in each proposal list
	//if we need more rows, we test for that condition and add as necessary
	GtkTreeIter P1_iter;
	gtk_list_store_append (impl->params->P1_ProposalList, &P1_iter);
	GtkTreeIter P2_iter;
	gtk_list_store_append (impl->params->P2_ProposalList, &P2_iter);
	
	
	
	for (i = properties; i != NULL && g_slist_next (i) != NULL; i = g_slist_next (g_slist_next (i))) 
	{
		const char *key;
		const char *value;
		gchar *pval_enc;
		gchar *pval_auth;
		
		gtk_list_store_get_value (impl->params->P1_ProposalList, &P1_iter, 0, pval_enc);
		gtk_list_store_get_value (impl->params->P1_ProposalList, &P1_iter, 1, pval_auth);
		
		if ( ((strlen (pval_enc) > 0) && strlen (pval_auth) > 0) )
			gtk_list_store_append (impl->params->P1_ProposalList, &P1_iter);
		g_free(pval_enc);
		g_free(pval_auth);
		
		gtk_list_store_get_value (impl->params->P2_ProposalList, &P2_iter, 0, pval_enc);
		gtk_list_store_get_value (impl->params->P2_ProposalList, &P2_iter, 1, pval_auth);
		
		if ( ((strlen (pval_enc) > 0) && strlen (pval_auth) > 0) )
			gtk_list_store_append (impl->params->P1_ProposalList, &P1_iter);
		g_free(pval_enc);
		g_free(pval_auth);

		key = i->data;
		value = (g_slist_next (i))->data;

		if (strcmp (key, NMOS_STRING_NAME) == 0) 
			gtk_entry_set_text (impl->w_name, value);
		else if (strcmp (key, NMOS_STRING_REMOTE_GATEWAY) == 0) 
			gtk_entry_set_text (impl->w_gateway, value);
		else if (strcmp (key, NMOS_STRING_REMOTE_NETWORK) == 0) 
			gtk_entry_set_text (impl->w_remote_network, value);
		else if (strcmp (key, NMOS_STRING_REMOTE_SUBNET_MASK) == 0) 
			gtk_entry_set_text (impl->w_remote_netmask, value);
		else if (strcmp (key, NMOS_STRING_AUTH_METHOD) == 0) 
		{
			if (strcmp(value, "PSK") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_radiobutton_psk), TRUE);
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_radiobutton_cert), FALSE);
			}
			else if (strcmp(value, "CERT") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_radiobutton_psk), FALSE);
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_radiobutton_cert), TRUE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_AUTH_SECRET) == 0) 
		{
			if (gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (impl->w_radiobutton_psk)))
				gtk_entry_set_text (impl->w_PSK, value);
			else
			{
				//figure out what we do with a Certificate... when we actually support those thigns
			}
		}
		else if (strcmp (key, NMOS_STRING_XAUTH) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_xauth), TRUE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_configXauth), TRUE );
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (impl->w_xauth), FALSE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_configXauth), FALSE );
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_XAUTH_USERNAME) == 0) 
			gtk_entry_set_text (impl->w_xauthUsername, value);
		else if (strcmp (key, NMOS_STRING_XAUTH_PASSWORD) == 0) 
			gtk_entry_set_text (impl->w_xauthPassword, value);
		else if (strcmp (key, NMOS_STRING_INTERFACE_MODE) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_interfaceMode), TRUE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_configInterface), TRUE );
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_interfaceMode), FALSE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_configInterface), FALSE );
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_INTERFACE_NAME) == 0)
		{
			guint i;
			gtk_combo_box_set_active (impl->w_interface_name, 0);
			for (i = 0; i < 10; i++)
			{
				gchar *str_tmp;
				str_tmp = g_strdup_printf ("%d", i);
				if ( g_str_has_suffix (value, str_tmp) )
				{
					gtk_combo_box_set_active (impl->w_interface_name, i);
					break;
				}
			}
		}
		else if (strcmp (key, NMOS_STRING_INTERFACE_DHCP) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_vip_dhcp), TRUE);
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_vip_manual), FALSE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_IP), FALSE );
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_SnM), FALSE );
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_DNS), FALSE );
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_WINS), FALSE );
				gtk_expander_set_expanded(impl->w_confInt_Expander, FALSE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_vip_dhcp), FALSE);
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_vip_manual), TRUE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_IP), TRUE );
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_SnM), TRUE );
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_DNS), TRUE );
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_vip_WINS), TRUE );
				gtk_expander_set_expanded(impl->w_confInt_Expander, TRUE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_INTERFACE_IP_ADDRESS) == 0) 
			gtk_entry_set_text (impl->w_vip_IP, value);
		else if (strcmp (key, NMOS_STRING_INTERFACE_DNS_SERVER) == 0) 
			gtk_entry_set_text (impl->w_vip_DNS, value);
		else if (strcmp (key, NMOS_STRING_INTERFACE_WINS_SERVER) == 0) 
			gtk_entry_set_text (impl->w_vip_WINS, value);
		
		else if (strcmp (key, NMOS_STRING_PFS) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_PFS), TRUE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_PFS), FALSE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_DPD) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_DPD), TRUE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_DPD), FALSE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_NATT) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_NatT), TRUE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_NatT), FALSE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_REPLAY_DETECTION) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_ReplayDetection), TRUE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_ReplayDetection), FALSE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_AUTO_KEEPALIVE) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_auto_keepalive), TRUE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_keepalivefreq), TRUE );
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_auto_keepalive), FALSE);
				gtk_widget_set_sensitive(GTK_WIDGET(impl->w_keepalivefreq), FALSE );
			}
			//else
				//error in data recieved.
		}		
		else if (strcmp (key, NMOS_STRING_KEEP_ALIVE_FREQUENCY) == 0) 
			gtk_entry_set_text (impl->w_keepalivefreq, value);

		
		//here we have to handle the list of elements for phase 1 and 2 params
		else if (strcmp (key, NMOS_STRING_PHASE1_MODE) == 0) 
		{
			if (strcmp(value, "MAIN") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_mainmode), TRUE);
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_aggressivemode), FALSE);
			}
			else if (strcmp(value, "AGGRESSIVE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_mainmode), FALSE);
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_aggressivemode), TRUE);
			}
			//else
				//error in data recieved.
		}		

		else if (strcmp (key, NMOS_STRING_PHASE1_DH_GROUP_1) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_p1_dh1), TRUE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_p1_dh1), FALSE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_PHASE1_DH_GROUP_2) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_p1_dh2), TRUE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_p1_dh2), FALSE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_PHASE1_DH_GROUP_5) == 0) 
		{
			if (strcmp(value, "TRUE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_p1_dh5), TRUE);
			}
			else if (strcmp(value, "FALSE") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_p1_dh5), FALSE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_PHASE1_KEYLIFE) == 0) 
			gtk_entry_set_text (impl->w_P1_keylife, value);
		else if (strcmp (key, NMOS_STRING_PHASE1_LOCAL_ID) == 0) 
			gtk_entry_set_text (impl->w_P1_localid, value);
		//proposal list processing
		else if (strcmp (key, NMOS_STRING_PHASE1_AUTH) == 0) 
		{
			gtk_list_store_set (impl->params->P1_ProposalList, &P1_iter, 1, value, -1);
		}
		else if (strcmp (key, NMOS_STRING_PHASE1_ENC) == 0) 
		{
			gtk_list_store_set (impl->params->P1_ProposalList, &P1_iter, 0, value, -1); 
		}
		
		else if (strcmp (key, NMOS_STRING_PHASE2_DH_GROUP) == 0) 
		{
			if (strcmp(value, "1") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_P2_dh1), TRUE);
			}
			else if (strcmp(value, "2") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_P2_dh2), TRUE);
			}
			else if (strcmp(value, "5") == 0)
			{
				gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (impl->w_P2_dh5), TRUE);
			}
			//else
				//error in data recieved.
		}
		else if (strcmp (key, NMOS_STRING_PHASE2_KEYLIFE) == 0) 
			gtk_entry_set_text (impl->w_P2_keylife, value);
		//proposal list processing
		else if (strcmp (key, NMOS_STRING_PHASE2_AUTH) == 0) 
		{
			gtk_list_store_set (impl->params->P2_ProposalList, &P2_iter, 1, value, -1); 
		}
		else if (strcmp (key, NMOS_STRING_PHASE2_ENC) == 0) 
		{
			gtk_list_store_set (impl->params->P2_ProposalList, &P2_iter, 0, value, -1); 
		}

	}
	
	return (impl->widget);

error:
	g_free (impl);

	return NULL;
}	


static GSList *
impl_get_properties (NetworkManagerVpnUI *self)
{
	GSList *data;
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;
	GtkTreeIter iter;
	
	// get values from all widgets. Some may be null forcing the default values of others.
	// Empty text boxes default to entry "<none>" which gets filtered when processing messages
	// passed on the DBUS to the service handler
	
	g_string_assign (impl->params->name, gtk_entry_get_text (impl->w_name));
	g_string_assign (impl->params->gateway, gtk_entry_get_text (impl->w_gateway));
	g_string_assign (impl->params->remote_network, gtk_entry_get_text (impl->w_remote_network));
	g_string_assign (impl->params->remote_netmask, gtk_entry_get_text (impl->w_remote_netmask));
	if ((gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (impl->w_radiobutton_psk))))
	{
		impl->params->radiobutton_psk = TRUE;
		impl->params->radiobutton_cert = FALSE;
	}
	else if ((gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_radiobutton_cert))))
	{
		impl->params->radiobutton_psk = FALSE;
		impl->params->radiobutton_cert = TRUE;
	}
	g_string_assign (impl->params->PSK, gtk_entry_get_text (impl->w_PSK));
	g_string_assign (impl->params->P1_keylife, gtk_entry_get_text (impl->w_P1_keylife));
	g_string_assign (impl->params->P1_localid, gtk_entry_get_text (impl->w_P1_localid));
	g_string_assign (impl->params->P2_keylife, gtk_entry_get_text (impl->w_P2_keylife));
	
	//advanced buttons
	impl->params->PFS = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_PFS));
	impl->params->DPD = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_DPD));
	impl->params->NatT = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_NatT));
	impl->params->ReplayDetection = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_ReplayDetection));
	impl->params->auto_keepalive = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_auto_keepalive));
	g_string_assign (impl->params->keepalivefreq, gtk_entry_get_text (impl->w_keepalivefreq));
	
	//Phase1 toggle switches
	impl->params->p1_dh1 = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_p1_dh1));
	impl->params->p1_dh2 = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_p1_dh2));
	impl->params->p1_dh5 = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_p1_dh5));
	impl->params->p2_dh1 = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_p1_dh1));
	impl->params->p2_dh2 = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_p1_dh2));
	impl->params->p2_dh5 = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_p1_dh5));

	//which mode
	impl->params->mainmode = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (impl->w_mainmode));
	impl->params->aggressivemode = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (impl->w_aggressivemode));
	
	//Get the proposals lists
	impl->params->P1_ProposalList = GTK_LIST_STORE (gtk_tree_view_get_model ( impl->w_P1_ProposalList));
	impl->params->P2_ProposalList = GTK_LIST_STORE (gtk_tree_view_get_model ( impl->w_P2_ProposalList));
		
	//Interface Parameters
	impl->params->interfaceMode = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (impl->w_interfaceMode));
	g_string_assign (impl->params->interface_name, gtk_combo_box_get_active_text (impl->w_interface_name));
	impl->params->vip_dhcp = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (impl->w_vip_dhcp));
	impl->params->vip_manual = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (impl->w_vip_manual));
	g_string_assign (impl->params->vip_IP, gtk_entry_get_text (impl->w_vip_IP));
	g_string_assign (impl->params->vip_SnM, gtk_entry_get_text (impl->w_vip_SnM));
	g_string_assign (impl->params->vip_DNS, gtk_entry_get_text (impl->w_vip_DNS));
	g_string_assign (impl->params->vip_WINS, gtk_entry_get_text (impl->w_vip_WINS));

	// xauth params
	impl->params->xauth = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_xauth));
	impl->params->promptXauth = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (impl->w_promptXauth));
	g_string_assign (impl->params->xauthUsername, gtk_entry_get_text (impl->w_xauthUsername));
	g_string_assign (impl->params->xauthPassword, gtk_entry_get_text (impl->w_xauthPassword));

	
	
	//strings appended in reverse using prepend to improve performance
	//append would force the traversal of the list to find the end each time
	
	data = NULL;
	
	gboolean isvalid;
	gchar  *plistdata;
	
	if (!(gtk_tree_model_get_iter_first (GTK_TREE_MODEL(impl->params->P2_ProposalList), &iter)))
	{
		nm_error ("Cannot Have empty Phase 2 Proposal List");
		//return FALSE;
	}
	
	isvalid = TRUE;
	while (isvalid)
	{
		gtk_tree_model_get (GTK_TREE_MODEL(impl->params->P2_ProposalList), &iter, 1, &plistdata, -1);
		
		data = g_slist_prepend (data, g_strdup (plistdata));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE2_AUTH));
		plistdata = g_strdup ("");
		//g_free (plistdata);
		gtk_tree_model_get (GTK_TREE_MODEL(impl->params->P2_ProposalList), &iter, 0, &plistdata, -1);
		data = g_slist_prepend (data, g_strdup (plistdata));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE2_ENC));
		
		if (!gtk_tree_model_iter_next (GTK_TREE_MODEL(impl->params->P2_ProposalList), &iter))
			isvalid = FALSE;
	}
	
	data = g_slist_prepend (data, g_strdup (impl->params->P2_keylife->str));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE2_KEYLIFE));
	if (impl->w_P2_dh1)
		g_slist_prepend (data, g_strdup ("1"));
	else if (impl->w_P2_dh2)
		g_slist_prepend (data, g_strdup ("2"));
	else if (impl->w_P2_dh5)
		g_slist_prepend (data, g_strdup ("5"));
	else 
		g_slist_prepend (data, g_strdup (NMOS_STRING_VAL_ERR));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE2_DH_GROUP));
	
	g_free (&iter);
	if (!(gtk_tree_model_get_iter_first (GTK_TREE_MODEL(impl->params->P1_ProposalList), &iter)))
	{
		nm_error ("Cannot Have empty Phase 1 Proposal List");
		//return FALSE;
	}	
	isvalid = TRUE;
	while (isvalid)
	{
		gtk_tree_model_get (GTK_TREE_MODEL(impl->params->P1_ProposalList), &iter, 1, &plistdata, -1);
		data = g_slist_prepend (data, g_strdup (plistdata));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_AUTH));
		//free plistdata?
		gtk_tree_model_get ( GTK_TREE_MODEL(impl->params->P1_ProposalList), &iter, 0, &plistdata, -1);
		data = g_slist_prepend (data, g_strdup (plistdata));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_ENC));

		if (!gtk_tree_model_iter_next (GTK_TREE_MODEL(impl->params->P1_ProposalList), &iter))
			isvalid = FALSE;
	}
	data = g_slist_prepend (data, g_strdup (impl->params->P1_localid->str));	
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_LOCAL_ID));
	data = g_slist_prepend (data, g_strdup (impl->params->P2_keylife->str));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_KEYLIFE));
	if (impl->params->p1_dh5)
		data = g_slist_prepend (data, g_strdup ("TRUE"));
	else
		data = g_slist_prepend (data, g_strdup ("FALSE"));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_DH_GROUP_5));
	if (impl->params->p1_dh2)
		data = g_slist_prepend (data, g_strdup ("TRUE"));
	else
		data = g_slist_prepend (data, g_strdup ("FALSE"));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_DH_GROUP_2));
	if (impl->params->p1_dh1)
		data = g_slist_prepend (data, g_strdup ("TRUE"));
	else
		data = g_slist_prepend (data, g_strdup ("FALSE"));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_DH_GROUP_1));
	if (impl->params->mainmode)
		data = g_slist_prepend (data, g_strdup ("MAIN"));
	else if (impl->params->aggressivemode)
		data = g_slist_prepend (data, g_strdup ("AGGRESIVE"));
	else
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_VAL_ERR));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_PHASE1_MODE));
	
	//interface mode options
	if (impl->params->interfaceMode) 
	{
		if (impl->params->vip_manual)
		{
			data = g_slist_prepend (data, g_strdup (impl->params->vip_WINS->str));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_WINS_SERVER));
			data = g_slist_prepend (data, g_strdup (impl->params->vip_DNS->str));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_DNS_SERVER));
			data = g_slist_prepend (data, g_strdup (impl->params->vip_SnM->str));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_SUBNET_MASK));
			data = g_slist_prepend (data, g_strdup (impl->params->vip_IP->str));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_IP_ADDRESS));
			data = g_slist_prepend (data, g_strdup ("FALSE"));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_DHCP));
		    
			
		}
		else if (impl->params->vip_dhcp)
		{
			/*
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_WINS_SERVER));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_VAL_NONE));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_DNS_SERVER));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_VAL_NONE));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_SUBNET_MASK));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_VAL_NONE));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_IP_ADDRESS));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_VAL_NONE));
			*/
			data = g_slist_prepend (data, g_strdup ("TRUE"));
			data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_DHCP));
		    
		}
		else 
		{
			//WE SHOULD NEVER GET HERE
		}
		//add the last option for interface mode
		data = g_slist_prepend (data, g_strdup (impl->params->interface_name->str));	
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_NAME));
		data = g_slist_prepend (data, g_strdup ("TRUE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_MODE));
	}
	else
	{
		data = g_slist_prepend (data, g_strdup ("FALSE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_INTERFACE_MODE));
	}
	
	if (impl->params->auto_keepalive)
	{
		data = g_slist_prepend (data, g_strdup (impl->params->keepalivefreq->str));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_KEEP_ALIVE_FREQUENCY));
		data = g_slist_prepend (data, g_strdup ("TRUE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_AUTO_KEEPALIVE));
	}
	else
	{
		data = g_slist_prepend (data, g_strdup ("FALSE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_AUTO_KEEPALIVE));
	}
	
	if (impl->params->ReplayDetection)
	{
		data = g_slist_prepend (data, g_strdup ("TRUE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_REPLAY_DETECTION));
	}
	else
	{
		data = g_slist_prepend (data, g_strdup ("FALSE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_REPLAY_DETECTION));
	}
	if (impl->params->NatT)
	{
		data = g_slist_prepend (data, g_strdup ("TRUE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_NATT));
	}
	else
	{
		data = g_slist_prepend (data, g_strdup ("FALSE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_NATT));
	}

	if (impl->params->NatT)
	{
		data = g_slist_prepend (data, g_strdup ("TRUE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_DPD));
	}
	else
	{
		data = g_slist_prepend (data, g_strdup ("FALSE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_DPD));
	}
	
	if (impl->params->PFS)
	{
		data = g_slist_prepend (data, g_strdup ("TRUE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_PFS));
	}
	else
	{
		data = g_slist_prepend (data, g_strdup ("FALSE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_PFS));
	}
	
	if (impl->params->xauth)
	{
		data = g_slist_prepend (data, g_strdup (impl->params->xauthPassword->str));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_XAUTH_PASSWORD));
		data = g_slist_prepend (data, g_strdup (impl->params->xauthUsername->str));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_XAUTH_USERNAME));
		data = g_slist_prepend (data, g_strdup ("TRUE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_XAUTH));
	}
	else
	{
		data = g_slist_prepend (data, g_strdup ("FALSE"));
		data = g_slist_prepend (data, g_strdup (NMOS_STRING_XAUTH));
	}
	
	//Basic Settings
	data = g_slist_prepend (data, g_strdup (impl->params->PSK->str));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_AUTH_SECRET));
	if (impl->params->radiobutton_psk)
		data = g_slist_prepend (data, g_strdup ("PSK"));
	else if (impl->params->radiobutton_cert)
		data = g_slist_prepend (data, g_strdup ("CERT"));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_AUTH_METHOD));
	data = g_slist_prepend (data, g_strdup (impl->params->remote_netmask->str));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_REMOTE_SUBNET_MASK));
	data = g_slist_prepend (data, g_strdup (impl->params->remote_network->str));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_REMOTE_NETWORK));
	data = g_slist_prepend (data, g_strdup (impl->params->gateway->str));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_REMOTE_GATEWAY));
	data = g_slist_prepend (data, g_strdup (impl->params->name->str));
	data = g_slist_prepend (data, g_strdup (NMOS_STRING_NAME));
	
	//set helper variable
	impl->HAVE_DATA_LIST = TRUE;
	return data;
}


static GSList *
impl_get_routes (NetworkManagerVpnUI *self)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;
	
	GSList *routes = NULL;
	
	g_slist_append (routes, g_strdup_printf("%s/%s", impl->params->remote_network, impl->params->remote_netmask));

	return routes;
}


static char *
impl_get_connection_name (NetworkManagerVpnUI *self)
{
	const char *name;
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;

	name = gtk_entry_get_text (impl->w_name);
	if (name != NULL)
		return g_strdup (name);
	else
		return NULL;
}

static gboolean
impl_is_valid (NetworkManagerVpnUI *self)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;
	gboolean is_valid = FALSE;

/*
	if (!impl->HAVE_DATA_LIST)
		impl_get_properties(self);
*/	
	
	//validate all text widget entries (IP addresses / hostnames / integer values)
	//initial sanity checks
/*	
	if ( (impl->params->name->len) <= 0 || (impl->params->gateway->len) <= 0 || (impl->params->remote_network->len) <= 0 || \
		(impl->params->remote_netmask->len) <= 0 || (impl->params->PSK->len) <= 0)
		is_valid = FALSE;
	//verify Phase 1 and 2 proposal sets
	//GtkListStore 
	else if ()
	{
		
		
	}
*/
	//verify Boolean Values
		
	return is_valid;
}


static void 
impl_set_validity_changed_callback (NetworkManagerVpnUI *self, 
				    NetworkManagerVpnUIDialogValidityCallback callback,
				    gpointer user_data)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;

	impl->callback = callback;
	impl->callback_user_data = user_data;
}


static void
impl_get_confirmation_details (NetworkManagerVpnUI *self, gchar **retval)
{
	GString *buf;
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;
	
	*retval = g_string_free (buf, FALSE);
}


static gboolean 
impl_can_export (NetworkManagerVpnUI *self)
{
	return FALSE;
}


static gboolean 
impl_import_file (NetworkManagerVpnUI *self, const char *path)
{
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;

	//return import_from_file (impl, path);
	return FALSE; //for now
}


static gboolean 
impl_export (NetworkManagerVpnUI *self, GSList *properties, GSList *routes, const char *connection_name)
{
	char *suggested_name;
	char *path = NULL;
	GtkWidget *dialog;
	NetworkManagerVpnUIImpl *impl = (NetworkManagerVpnUIImpl *) self->data;

	/*printf ("in impl_export\n");*/

	dialog = gtk_file_chooser_dialog_new (_("Save as..."),
					      NULL,
					      GTK_FILE_CHOOSER_ACTION_SAVE,
					      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
					      NULL);

	suggested_name = g_strdup_printf ("%s_ipsec.conf", connection_name);
	gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (dialog), suggested_name);
	g_free (suggested_name);

	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
		
		path = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		/*printf ("User selected '%s'\n", path);*/

	}

	gtk_widget_destroy (dialog);

	if (path != NULL) {
		if (g_file_test (path, G_FILE_TEST_EXISTS)) {
			int response;
			GtkWidget *dialog;

			dialog = gtk_message_dialog_new (NULL,
							 GTK_DIALOG_DESTROY_WITH_PARENT,
							 GTK_MESSAGE_QUESTION,
							 GTK_BUTTONS_CANCEL,
							 _("A file named \"%s\" already exists."), path);
			gtk_dialog_add_buttons (GTK_DIALOG (dialog), "_Replace", GTK_RESPONSE_OK, NULL);
			gtk_message_dialog_format_secondary_text (GTK_MESSAGE_DIALOG (dialog),
								  _("Do you want to replace it with the one you are saving?"));
			response = gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy (dialog);
			if (response != GTK_RESPONSE_OK)
				goto out;
		}
		//if the export fails....
		if (!export_to_file (impl, path, properties, routes, connection_name)) {
			GtkWidget *dialog;

			dialog = gtk_message_dialog_new (NULL,
									   GTK_DIALOG_DESTROY_WITH_PARENT,
									   GTK_MESSAGE_WARNING,
									   GTK_BUTTONS_CLOSE,
									   _("Failed to export configuration"));
			gtk_message_dialog_format_secondary_text (GTK_MESSAGE_DIALOG (dialog),
											  _("Failed to save file %s"), path);
			gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy (dialog);
		}
	}

out:
	g_free (path);
//else we return true for success!
	return TRUE;
}


/*
 * Helper Function to clear all values in the dialog (and sub dialogs)
 * Also used for the reset button functionality
 *
 */

void libnmos_clear_widget (NetworkManagerVpnUIImpl *impl)
{
	GtkTextBuffer *buf;
	
	//set all text widgets first.
	gtk_entry_set_text (impl->w_name, "");
	gtk_entry_set_text (impl->w_gateway, "");
	gtk_entry_set_text (impl->w_remote_network, "");
	gtk_entry_set_text (impl->w_remote_netmask, "");
	gtk_entry_set_text (impl->w_PSK, "");
	gtk_entry_set_text (impl->w_P1_keylife, "");
	gtk_entry_set_text (impl->w_P1_localid, "");
	gtk_entry_set_text (impl->w_P2_keylife, "");
	gtk_entry_set_text (impl->w_keepalivefreq, "");

	//advanced buttons
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_PFS)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_DPD)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_NatT)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_ReplayDetection)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_auto_keepalive)), FALSE);
	
	//set all toggle switches
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_interfaceMode)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_xauth)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_p1_dh1)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_p1_dh2)), FALSE);
	gtk_toggle_button_set_active ( (GTK_TOGGLE_BUTTON (impl->w_p1_dh5)), FALSE);
	//set all radio buttons to off.
	gtk_toggle_button_set_state ( (GTK_TOGGLE_BUTTON (impl->w_radiobutton_psk)), FALSE);
	gtk_toggle_button_set_state ( (GTK_TOGGLE_BUTTON (impl->w_radiobutton_cert)), FALSE);
	gtk_toggle_button_set_state ( (GTK_TOGGLE_BUTTON (impl->w_mainmode)), FALSE);
	gtk_toggle_button_set_state ( (GTK_TOGGLE_BUTTON (impl->w_aggressivemode)), FALSE);
	//set Config buttons to grey-d out for now
	gtk_widget_set_sensitive ( (GTK_WIDGET (impl->w_configInterface)), FALSE);
	gtk_widget_set_sensitive ( (GTK_WIDGET (impl->w_configXauth)), FALSE);
	//clear the proposals lists
	gtk_list_store_clear ( (GTK_LIST_STORE (impl->w_P1_ProposalList)));
	gtk_list_store_clear ( (GTK_LIST_STORE (impl->w_P2_ProposalList)));
	//close the two expanders after clearing the proposals lists
	gtk_expander_set_expanded (impl->w_p1_expander, FALSE);
	gtk_expander_set_expanded (impl->w_p2_expander, FALSE);
	
	//clear the members of the popups
	gtk_toggle_button_set_state ( (GTK_TOGGLE_BUTTON (impl->w_vip_dhcp)), TRUE);
	gtk_toggle_button_set_state ( (GTK_TOGGLE_BUTTON (impl->w_vip_manual)), FALSE);

	gtk_entry_set_text (impl->w_vip_IP, "");
	gtk_entry_set_text (impl->w_vip_SnM, "");
	gtk_entry_set_text (impl->w_vip_DNS, "");
	gtk_entry_set_text (impl->w_vip_WINS, "");

	gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON(impl->w_xauth), FALSE);
	gtk_toggle_button_set_active (  GTK_TOGGLE_BUTTON(impl->w_promptXauth), FALSE);
	gtk_entry_set_text (impl->w_xauthUsername, "");
	gtk_entry_set_text (impl->w_xauthPassword, "");
	
	//reset prop window once we know how it behaves.

	//buf = get_text_view_buffer (impl->w_prop_Preview);
	//gtk_text_buffer_set_text (buf, "\n", -1);
	
	return;
}

static NetworkManagerVpnUI* 
impl_get_object (void)
{
	char *glade_file;
	NetworkManagerVpnUIImpl *impl;

	g_type_init ();
	
	//init our data structure
	impl = g_new0 (NetworkManagerVpnUIImpl, 1);
	//init a nested structure
	impl->params = g_new0 (UIdata, 1);
	//init the proposals lists
	impl->params->P1_ProposalList = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING);
	impl->params->P2_ProposalList = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING);

	glade_file = g_strdup_printf ("%s/%s", GLADEDIR, "nm-openswan-dialog.glade");
	//nm_info ("Glade file path: %s", glade_file);
	impl->xml = glade_xml_new (glade_file, NULL, GETTEXT_PACKAGE);
	
	g_free (glade_file);
	if (impl->xml == NULL)
		goto error;

	//now lets pull our widgets from the XML file.
	// we save pointers to the widgets with data to reference their contents later
	// using the NetworkManagerVpnUIImpl  struct.
	
	impl->widget = glade_xml_get_widget (impl->xml, "nm-openswan-widget-window");
	
	impl->w_name = GTK_ENTRY (glade_xml_get_widget (impl->xml, "name"));
	impl->w_gateway         = GTK_ENTRY (glade_xml_get_widget (impl->xml, "gateway"));
	impl->w_remote_network  = GTK_ENTRY (glade_xml_get_widget (impl->xml, "remote_network"));
	impl->w_remote_network  = GTK_ENTRY (glade_xml_get_widget (impl->xml, "remote_netmask"));
	impl->w_radiobutton_psk          = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "radiobutton_psk"));
	impl->w_radiobutton_cert         = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "radiobutton_cert"));
	//Do I need the Group for these radio buttons?
	impl->w_PSK                      = GTK_ENTRY (glade_xml_get_widget (impl->xml, "PSK"));
	
	//Phase1 Data
	impl->w_mainmode             = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "mainmode"));
	impl->w_aggressivemode    = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "aggressivemode"));
	impl->w_p1_dh1                   = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "p1_dh1"));
	impl->w_p1_dh2                   = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "p1_dh2"));
	impl->w_p1_dh5                   = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "p1_dh5"));
	impl->w_P1_keylife               = GTK_ENTRY (glade_xml_get_widget (impl->xml, "P1_keylife"));
	impl->w_P1_ProposalList      = GTK_TREE_VIEW (glade_xml_get_widget (impl->xml, "P1_ProposalList"));
	//bind the ListStore data struct to this widget
	gtk_tree_view_set_model (impl->w_P1_ProposalList, GTK_TREE_MODEL (impl->params->P1_ProposalList));
	
	//Phase2 Data
	impl->w_P2_dh1                    = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "P2_dh1"));
	impl->w_P2_dh2                    = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "P2_dh2"));
	impl->w_P2_dh5                    = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "P2_dh5"));
	impl->w_P2_keylife                = GTK_ENTRY (glade_xml_get_widget (impl->xml, "P2_keylife"));
	impl->w_P2_ProposalList           = GTK_TREE_VIEW (glade_xml_get_widget (impl->xml, "P2_ProposalList"));
	//bind the ListStore data struct to this widget
	gtk_tree_view_set_model (impl->w_P2_ProposalList, GTK_TREE_MODEL (impl->params->P2_ProposalList));
	
	//Advanced Options.
	impl->w_PFS                       = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "PFS"));
	impl->w_DPD                       = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "DPD"));
	impl->w_NatT                      = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "PFS"));
	impl->w_ReplayDetection           = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "ReplayDetection"));
	
	// Virtual Interface Options
	impl->w_interfaceMode			= GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "interfaceMode"));
	impl->w_confInt_Expander          = GTK_EXPANDER (glade_xml_get_widget (impl->xml, "confInt_Expander"));
	impl->w_vip_dhcp                  = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "vip_dhcp"));
	impl->w_vip_manual                = GTK_RADIO_BUTTON (glade_xml_get_widget (impl->xml, "vip_manual"));
	impl->w_interface_name            = GTK_COMBO_BOX (glade_xml_get_widget (impl->xml, "vip_name"));
	impl->w_vip_IP                    = GTK_ENTRY (glade_xml_get_widget (impl->xml, "vip_IP"));
	impl->w_vip_SnM                   = GTK_ENTRY (glade_xml_get_widget (impl->xml, "vip_SnM"));
	impl->w_vip_DNS                   = GTK_ENTRY (glade_xml_get_widget (impl->xml, "vip_DNS"));	
	impl->w_vip_WINS                  = GTK_ENTRY (glade_xml_get_widget (impl->xml, "vip_WINS"));
	
	//control buttons for all dialogs
	impl->w_newProp_OK                = GTK_BUTTON (glade_xml_get_widget (impl->xml, "newProp_OK"));
	impl->w_newProp_Reset             = GTK_BUTTON (glade_xml_get_widget (impl->xml, "newProp_Reset"));
	impl->w_newProp_Cancel            = GTK_BUTTON (glade_xml_get_widget (impl->xml, "newProp_Cancel"));
	
	//xauth widgets
	impl->w_xauth                     = GTK_CHECK_BUTTON (glade_xml_get_widget (impl->xml, "xauth"));
	impl->w_configXauth               = GTK_BUTTON (glade_xml_get_widget (impl->xml, "configXauth"));
	impl->w_confXauthOK               = GTK_BUTTON (glade_xml_get_widget (impl->xml, "confXauthOK"));
	impl->w_confXauthCancel           = GTK_BUTTON (glade_xml_get_widget (impl->xml, "confXauthCancel"));
	
	impl->callback                    = NULL;

	g_signal_connect ( (impl->w_radiobutton_psk), "activate",
                        G_CALLBACK (on_psk_activated),
                        impl);
						
	g_signal_connect ( (impl->w_radiobutton_cert), "activate",
                        G_CALLBACK (on_cert_activated),
                        impl);
						
	g_signal_connect ( (impl->w_interfaceMode), "toggled",
						G_CALLBACK (on_interfaceMode_toggled),
						impl);
						
	g_signal_connect ( (impl->w_configInterface), "clicked",
						G_CALLBACK (on_configInterface_clicked),
						impl);
						
	g_signal_connect ( (impl->w_xauth), "toggled",
						G_CALLBACK (on_xauth_toggled),
						impl);
	
	g_signal_connect ( (impl->w_configXauth), "clicked",
						G_CALLBACK (on_configXauth_clicked),
					    impl);
	
	g_signal_connect ( (impl->w_P1_Add), "clicked",
						G_CALLBACK (on_P1_Add_clicked),
						impl);
	
	g_signal_connect ( (impl->w_P1_Delete), "clicked",
						G_CALLBACK (on_P1_Delete_clicked),
						impl);
	
	g_signal_connect ( (impl->w_P1_DeleteAll), "clicked",
						G_CALLBACK (on_P1_DeleteAll_clicked),
						impl);
	g_signal_connect ( (impl->w_P2_Add), "clicked",
						G_CALLBACK (on_P2_Add_clicked),
						impl);
	
	g_signal_connect ( (impl->w_P2_Delete), "clicked",
						G_CALLBACK (on_P2_Delete_clicked),
						impl);
	
	g_signal_connect ( (impl->w_P2_DeleteAll), "clicked",
						G_CALLBACK (on_P2_DeleteAll_clicked),
						impl);
	
	g_signal_connect ( (impl->w_newconn_OK), "clicked",
						G_CALLBACK (on_newconn_OK_clicked),
						impl);
	
	g_signal_connect ( (impl->w_newconn_Cancel), "clicked",
						G_CALLBACK (on_newconn_Cancel_clicked),
						impl);

	g_signal_connect ( (impl->w_Import), "clicked", 
						G_CALLBACK (on_Import_clicked), 
						impl);

	/* make the widget reusable */
	g_signal_connect ( GTK_OBJECT (impl->widget), "delete-event", 
			    G_CALLBACK (gtk_widget_hide_on_delete), 
			    NULL);

	//libnmos_clear_widget (impl);

	impl->parent.get_display_name = impl_get_display_name;
	impl->parent.get_service_name = impl_get_service_name;
	impl->parent.get_widget = impl_get_widget;
	impl->parent.get_connection_name = impl_get_connection_name;
	impl->parent.get_properties = impl_get_properties;
	impl->parent.get_routes = impl_get_routes;
	impl->parent.set_validity_changed_callback = impl_set_validity_changed_callback;
	impl->parent.is_valid = impl_is_valid;
	impl->parent.get_confirmation_details = impl_get_confirmation_details;
	impl->parent.can_export = impl_can_export;
	impl->parent.import_file = impl_import_file;
	impl->parent.export = impl_export;
	impl->parent.data = impl;
	
	return &(impl->parent);

error:
	g_free (impl);
	return NULL;
}

NetworkManagerVpnUI* nm_vpn_properties_factory (void)
{
	return impl_get_object ();
}


