/* nm-openswan-service - openswan integration with NetworkManager
 *
 * Steve Hillier <keyhman@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * (C) Copyright 2007 Steve Hillier
 */

#ifndef NM_OPENSWAN_SERVICE_H
#define NM_OPENSWAN_SERVICE_H

/* Lets Define The Message Strings that identify
 * each Arg passed to nm-os on the DBUS
 */

#define NMOS_STRING_NAME		             "Name"
#define NMOS_STRING_REMOTE_GATEWAY           "Remote Gateway"             /* Remote gateway */
#define NMOS_STRING_REMOTE_NETWORK		     "Remote Network"             /* Remote Network */
#define NMOS_STRING_REMOTE_SUBNET_MASK       "Subnet Mask"                /* Subnet Mask */
#define NMOS_STRING_AUTH_METHOD		         "Auth Method"                /* Auth Method */
#define NMOS_STRING_AUTH_SECRET              "Auth Secret"
#define NMOS_STRING_XAUTH		             "Xauth"
#define NMOS_STRING_XAUTH_USERNAME		     "Xauth Username"
#define NMOS_STRING_XAUTH_PASSWORD	 	     "Xauth Password"
#define NMOS_STRING_PFS		                 "PFS"
#define NMOS_STRING_DPD		                 "DPD"
#define NMOS_STRING_NATT		             "Nat-T"
#define NMOS_STRING_REPLAY_DETECTION		 "Replay Detection"
#define NMOS_STRING_AUTO_KEEPALIVE		     "Auto KeepAlive"
#define NMOS_STRING_KEEP_ALIVE_FREQUENCY	 "Keep Alive Frequency"
#define NMOS_STRING_INTERFACE_MODE		     "Interface Mode"
#define NMOS_STRING_INTERFACE_NAME		     "Interface: Name"
#define NMOS_STRING_INTERFACE_DHCP		     "Interface: DHCP"
#define NMOS_STRING_INTERFACE_IP_ADDRESS     "Interface: IP Address"
#define NMOS_STRING_INTERFACE_SUBNET_MASK	 "Interface: Subnet Mask"
#define NMOS_STRING_INTERFACE_DNS_SERVER     "Interface: DNS Server"
#define NMOS_STRING_INTERFACE_WINS_SERVER    "Interface: WINS Server"
#define NMOS_STRING_PHASE1_MODE		         "Phase1: Mode"
#define NMOS_STRING_PHASE1_DH_GROUP_1		 "Phase1: DH Group 1"
#define NMOS_STRING_PHASE1_DH_GROUP_2		 "Phase1: DH Group 2"
#define NMOS_STRING_PHASE1_DH_GROUP_5		 "Phase1: DH Group 5"
#define NMOS_STRING_PHASE1_KEYLIFE		     "Phase1: Keylife"
#define NMOS_STRING_PHASE1_LOCAL_ID		     "Phase1: LocalID"
#define NMOS_STRING_PHASE1_AUTH		         "Phase1: Auth"
#define NMOS_STRING_PHASE1_ENC		         "Phase1: Enc"
#define NMOS_STRING_PHASE2_DH_GROUP		     "Phase2: DH Group"
#define NMOS_STRING_PHASE2_KEYLIFE		     "Phase2: Keylife"
#define NMOS_STRING_PHASE2_AUTH		         "Phase2: Auth"
#define NMOS_STRING_PHASE2_ENC		         "Phase2: Enc"
#define NMOS_STRING_VAL_ERR                  "VAL_ERR"
#define NMOS_STRING_VAL_NONE                 "<NONE>"


#define NM_DBUS_SERVICE_OPENSWAN	"org.freedesktop.NetworkManager.openswan"
#define NM_DBUS_INTERFACE_OPENSWAN	"org.freedesktop.NetworkManager.openswan"
#define NM_DBUS_PATH_OPENSWAN	"/org/freedesktop/NetworkManager/openswan"

#define NM_OPENSWAN_HELPER_PATH	_BINDIR  "/nm-openswan-service-openswan-helper"
#define NM_OPENSWAN_UDP_ENCAPSULATION_PORT	0 /* random port */
#define NM_OPENSWAN_REKEYING_INTERVAL 7200 /* default interval of 2 hours */

//#define PLUTO_PID_FILE    "//var/run/pluto/pluto.pid"

static const char *plutoctl_paths[] =
{
	"/var/pluto.ctl",
	"/var/run/pluto/pluto.ctl",
	NULL
};

static const char *whackbin_paths[] =
{
	"/usr/libexec/ipsec/whack",
	"/usr/local/libexec/ipsec/whack",
	"/usr/local/openswan/libexec/whack",
	NULL
};

// call out to prompt for Xauth (GTK widget, console support later).
//extern gboolean prompt_xauth (char *username, char *password);

//#include "libnm-os-xauth.h"

#endif
